package com.logicbig.example;

import org.fluttercode.datafactory.impl.DataFactory;

import javax.annotation.PostConstruct;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@ManagedBean
@ViewScoped
public class EmployeeBean {
    private List<Employee> employeeList = new ArrayList<>();
    private Employee selectedEmployee;

    @PostConstruct
    private void postConstruct() {
        String[] deptList = {"IT", "Account", "Admin", "Sale", "Inventory"};
        DataFactory dataFactory = new DataFactory();
        dataFactory.randomize(100);
        for (int i = 1; i < 20; i++) {
            Employee employee = new Employee();
            employee.setId(i);
            String firstName = dataFactory.getFirstName();
            String lastName = dataFactory.getLastName();
            employee.setName(firstName + " " + lastName);
            EmployeeDetails details = new EmployeeDetails();
            details.setDept(dataFactory.getItem(deptList));
            details.setPhoneNumber(String.format("%s-%s-%s", dataFactory.getNumberText(3),
                    dataFactory.getNumberText(3),
                    dataFactory.getNumberText(4)));
            details.setEmail(firstName.toLowerCase() + "@example.com");
            details.setAddress(dataFactory.getAddress() + "," + dataFactory.getCity());
            details.setEmployedSince(dataFactory.getDateBetween(new Date(0), new Date()));
            employee.setDetails(details);
            employeeList.add(employee);
        }
    }

    public void setSelectedEmployee(Employee selectedEmployee) {
        this.selectedEmployee = selectedEmployee;
    }

    public Employee getSelectedEmployee() {
        return selectedEmployee;
    }

    public List<Employee> getEmployeeList() {
        return employeeList;
    }
}